//+------------------------------------------------------------------+
//| ADX Crossing+FiboBars2.mq4 
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_color5 Red
#property indicator_color6 Green

//---- input parameters
extern int  ADXbars=14;
extern int  CountBars=350;
extern bool SoundON=true;
extern bool EmailON=false;
extern bool alertMode=false;
extern int  period=10;
extern int  fiboLevel=1;

double prevTicTrend=0;
bool oldIsTrandDown;
double level;
#define level1 0.236
#define level2 0.382
#define level3 0.5
#define level4 0.618
#define level5 0.762

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trand[];
double val1[];
double val2[];
int flagval1 = 0;
int flagval2 = 0;
double b4plusdi,nowplusdi,b4minusdi,nowminusdi;
datetime barTime=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,108);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,108);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
   GlobalVariableSet("AlertTime"+Symbol()+Period(),CurTime());
   GlobalVariableSet("SignalType"+Symbol()+Period(),OP_SELLSTOP);
   
   SetIndexBuffer(2,ExtMapBuffer1);
   SetIndexBuffer(3,ExtMapBuffer2);
   SetIndexBuffer(4,ExtMapBuffer3);
   SetIndexBuffer(5,ExtMapBuffer4);
   SetIndexBuffer(6,trand);

   SetIndexStyle(2,DRAW_HISTOGRAM,0,1);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,1);
   SetIndexStyle(4,DRAW_HISTOGRAM,0,3);
   SetIndexStyle(5,DRAW_HISTOGRAM,0,3);

   SetIndexDrawBegin(2,period);
   SetIndexDrawBegin(3,period);
   SetIndexDrawBegin(4,period);
   SetIndexDrawBegin(5,period);
   SetIndexDrawBegin(6,period);


   switch(fiboLevel)
     {
      case 1:
         level=level1;
         break;
      case 2:
         level=level2;
         break;
      case 3:
         level=level3;
         break;
      case 4:
         level=level4;
         break;
      case 5:
         level=level5;
         break;
      default:
         level=level1;
         break;
     }
//----
   return(0);
  }

int deinit()
{
   GlobalVariableDel("AlertTime"+Symbol()+Period());
   GlobalVariableDel("SignalType"+Symbol()+Period());
   return(0);
}

//+------------------------------------------------------------------+
//| ADX Crossing                                                     |
//+------------------------------------------------------------------+
int start()
  {
   double tmp=0;
      
   if (CountBars>=Bars) CountBars=Bars;
   if (CountBars>=1000) CountBars=950;
   SetIndexDrawBegin(0,Bars-CountBars + 12);
   SetIndexDrawBegin(1,Bars-CountBars + 12);
   int i,shift,counted_bars=IndicatorCounted();


   //---- check for possible errors
   if(counted_bars<0) return(-1);

   //---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=CountBars;i++) val1[CountBars-i]=0.0;
      for(i=1;i<=CountBars;i++) val2[CountBars-i]=0.0;
     } 

   for (shift = CountBars; shift>=0; shift--) 
   { 

   	b4plusdi=iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_PLUSDI,shift-1);
	   nowplusdi=iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_PLUSDI,shift);
	   b4minusdi=iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_MINUSDI,shift-1);
	   nowminusdi=iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_MINUSDI,shift); 
      if (b4plusdi>b4minusdi && nowplusdi<nowminusdi)
      {
	      if (shift == 1 && flagval1==0){  flagval1=1; flagval2=0; }
	      val1[shift]=Low[shift]-5*Point;
      }
      if (b4plusdi<b4minusdi && nowplusdi>nowminusdi) 
      {
         if (shift == 1 && flagval2==0) { flagval2=1; flagval1=0; }
	      val2[shift]=High[shift]+5*Point;
      }
   }
   if (flagval1==1 && CurTime() > GlobalVariableGet("AlertTime"+Symbol()+Period()) && GlobalVariableGet("SignalType"+Symbol()+Period())!=OP_BUY)
   {
      if (SoundON) Alert("BUY signal at Ask=",Ask,", Bid=",Bid,", Time=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period());
      if (EmailON) SendMail("BUY signal alert","BUY signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
      tmp = CurTime() + (Period()-MathMod(Minute(),Period()))*60;
      GlobalVariableSet("AlertTime"+Symbol()+Period(),tmp);
      GlobalVariableSet("SignalType"+Symbol()+Period(),OP_SELL);
   }
   
   if (flagval2==1 && CurTime() > GlobalVariableGet("AlertTime"+Symbol()+Period()) && GlobalVariableGet("SignalType"+Symbol()+Period())!=OP_SELL)
    {
      if (SoundON) Alert("SELL signal at Ask=",Ask,", Bid=",Bid,", Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period());
      if (EmailON) SendMail("SELL signal alert","SELL signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
      tmp = CurTime() + (Period()-MathMod(Minute(),Period()))*60;
      GlobalVariableSet("AlertTime"+Symbol()+Period(),tmp);
      GlobalVariableSet("SignalType"+Symbol()+Period(),OP_BUY);
   }
   int limit=Bars-counted_bars;
   for(i=limit; i>=0; i--) 
     {
      double maxHigh= High[iHighest(NULL,0,MODE_HIGH,period,i)];
      double minLow = Low[iLowest(NULL,0,MODE_LOW,period,i)];
      if(Open[i]>Close[i]) 
        {
         if(!(trand[i+1]<0 && (maxHigh-minLow)*level<(Close[i]-minLow))) 
           {
            trand[i]=1;
              } else {
            trand[i]=-1;
           }
           } else {
         if(!(trand[i+1]>0 && (maxHigh-minLow)*level<(maxHigh-Close[i]))) 
           {
            trand[i]=-1;
              } else {
            trand[i]=1;
           }
        }

      if(alertMode && i==0 && trand[0]!=trand[1]) 
        {
         if(barTime!=Time[0]) 
           {
            if(trand[0]==1) 
              {
               Alert("FiboBars2: "+Symbol()+" M "+Period()+": Signal: BUY");
                 } else if(trand[0]==-1){
               Alert("FiboBars2: "+Symbol()+" M "+Period()+": Signal: SELL");
              }
           }
         barTime=Time[0];

         if(prevTicTrend!=trand[0]) 
           {
            PlaySound("event.wav");
           }
         prevTicTrend=trand[0];

        }

      if(trand[i]==1) 
        {//RED BAR 
         ExtMapBuffer1[i] = High[i];
         ExtMapBuffer2[i] = Low[i];
         ExtMapBuffer3[i] = MathMax(Open[i], Close[i]);
         ExtMapBuffer4[i] = MathMin(Open[i], Close[i]);
           } else if(trand[i]==-1) {//GREEN BAR
         ExtMapBuffer1[i] = Low[i];
         ExtMapBuffer2[i] = High[i];
         ExtMapBuffer3[i] = MathMin(Open[i], Close[i]);
         ExtMapBuffer4[i] = MathMax(Open[i], Close[i]);
           } else {
         ExtMapBuffer1[i] = EMPTY_VALUE;
         ExtMapBuffer2[i] = EMPTY_VALUE;
         ExtMapBuffer3[i] = EMPTY_VALUE;
         ExtMapBuffer4[i] = EMPTY_VALUE;
        }
      }
   return(0);
  }
//+------------------------------------------------------------------+